//
//	OTPWSK32
//
//	Copyright (C) 1996,1997 NEC Corporation
//	All Rights Reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/otpsock/wsock32/winsockp.c $
//			$Revision: 2 $
//			$Date: 98/11/25 12:59p $
static char VssID[] = "$Header: /sotools/otpsock/wsock32/winsockp.c 2     98/11/25 12:59p Mizukosi $";

#include	<windows.h>
#include	<winsock.h>
#include	"../common.h"
#include	"otpwsk32.h"


INT APIENTRY EnumProtocolsA (LPINT lpiProtocols, LPVOID lpProtocolBuffer, LPDWORD lpdwBufferLength)
{
	INT	ret;

x_OutputDebugString("EnumProtocolsA ");

	ret = gft.EnumProtocolsA(lpiProtocols, lpProtocolBuffer, lpdwBufferLength);

	return ret;
}


INT APIENTRY EnumProtocolsW (LPINT lpiProtocols, LPVOID lpProtocolBuffer, LPDWORD lpdwBufferLength)
{
	INT ret;

x_OutputDebugString("EnumProtocolsW ");

	ret = gft.EnumProtocolsW(lpiProtocols, lpProtocolBuffer, lpdwBufferLength);

	return ret;
}


INT APIENTRY GetAddressByNameA (DWORD dwNameSpace, LPGUID lpServiceType, LPSTR lpServiceName,
				    LPINT lpiProtocols, DWORD dwResolution, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo,
				    LPVOID lpCsaddrBuffer, LPDWORD lpdwBufferLength, LPSTR lpAliasBuffer,
					LPDWORD lpdwAliasBufferLength)
{
	INT	ret;

x_OutputDebugString("GetAddressByNameA ");

	ret = gft.GetAddressByNameA(dwNameSpace, lpServiceType, lpServiceName, lpiProtocols, dwResolution,
					lpServiceAsyncInfo, lpCsaddrBuffer, lpdwBufferLength, lpAliasBuffer, lpdwAliasBufferLength);

	return ret;
}


INT APIENTRY GetAddressByNameW (DWORD dwNameSpace, LPGUID lpServiceType, LPWSTR lpServiceName,
					LPINT lpiProtocols, DWORD dwResolution, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo,
					LPVOID lpCsaddrBuffer, LPDWORD lpdwBufferLength, LPWSTR lpAliasBuffer,
					LPDWORD lpdwAliasBufferLength)
{
	INT	ret;

x_OutputDebugString("GetAddressByNameW ");

	ret = gft.GetAddressByNameW(dwNameSpace, lpServiceType, lpServiceName, lpiProtocols, dwResolution,
					lpServiceAsyncInfo, lpCsaddrBuffer, lpdwBufferLength, lpAliasBuffer, lpdwAliasBufferLength);

	return ret;
}


INT APIENTRY GetNameByTypeA (LPGUID lpServiceType, LPSTR lpServiceName, DWORD dwNameLength)
{
	INT	ret;

x_OutputDebugString("GetNameByTypeA ");

	ret = gft.GetNameByTypeA(lpServiceType, lpServiceName, dwNameLength);

	return ret;
}


INT APIENTRY GetNameByTypeW (LPGUID lpServiceType, LPWSTR lpServiceName, DWORD dwNameLength)
{
	INT	ret;

x_OutputDebugString("GetNameByTypeW ");

	ret = gft.GetNameByTypeW(lpServiceType, lpServiceName, dwNameLength);

	return ret;
}


INT APIENTRY GetServiceA (DWORD dwNameSpace, LPGUID lpGuid, LPSTR lpServiceName, DWORD dwProperties,
					LPVOID lpBuffer, LPDWORD lpdwBufferSize, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo)
{
	INT	ret;

x_OutputDebugString("GetServiceA ");

	ret = gft.GetServiceA(dwNameSpace, lpGuid, lpServiceName, dwProperties, lpBuffer, lpdwBufferSize, lpServiceAsyncInfo);

	return ret;
}


INT APIENTRY GetServiceW (DWORD dwNameSpace, LPGUID lpGuid, LPWSTR lpServiceName, DWORD dwProperties,
					LPVOID lpBuffer, LPDWORD lpdwBufferSize, LPSERVICE_ASYNC_INFO lpServiceAsyncInfo)
{
	INT	ret;

x_OutputDebugString("GetServiceW ");

	ret = gft.GetServiceW(dwNameSpace, lpGuid, lpServiceName, dwProperties, lpBuffer, lpdwBufferSize, lpServiceAsyncInfo);

	return ret;
}


INT APIENTRY GetTypeByNameA (LPSTR lpServiceName, LPGUID lpServiceType)
{
	INT	ret;

x_OutputDebugString("GetTypeByNameA ");

	ret = gft.GetTypeByNameA(lpServiceName, lpServiceType);

	return ret;
}


INT APIENTRY GetTypeByNameW (LPWSTR lpServiceName, LPGUID lpServiceType)
{
	INT	ret;

x_OutputDebugString("GetTypeByNameW ");

	ret = gft.GetTypeByNameW(lpServiceName, lpServiceType);

	return ret;
}


INT APIENTRY SetServiceA (DWORD dwNameSpace, DWORD dwOperation, DWORD dwFlags, LPSERVICE_INFOA lpServiceInfo,
				    LPSERVICE_ASYNC_INFO lpServiceAsyncInfo, LPDWORD lpdwStatusFlags)
{
	INT	ret;

x_OutputDebugString("SetServiceA ");

	ret = gft.SetServiceA(dwNameSpace, dwOperation, dwFlags, lpServiceInfo, lpServiceAsyncInfo, lpdwStatusFlags);

	return ret;
}


INT APIENTRY SetServiceW (DWORD dwNameSpace, DWORD dwOperation, DWORD dwFlags, LPSERVICE_INFOW lpServiceInfo,
				    LPSERVICE_ASYNC_INFO lpServiceAsyncInfo, LPDWORD lpdwStatusFlags)
{
	INT	ret;

x_OutputDebugString("SetServiceW ");

	ret = gft.SetServiceW(dwNameSpace, dwOperation, dwFlags, lpServiceInfo, lpServiceAsyncInfo, lpdwStatusFlags);

	return ret;
}


BOOL APIENTRY TransmitFile (SOCKET hSocket, HANDLE hFile, DWORD nNumberOfBytesToWrite, DWORD nNumberOfBytesPerSend,
				    LPOVERLAPPED lpOverlapped, LPTRANSMIT_FILE_BUFFERS lpTransmitBuffers, DWORD dwFlags)
{
	BOOL	ret;

x_OutputDebugString("TransmitFile ");

	ret = gft.TransmitFile (hSocket, hFile, nNumberOfBytesToWrite, nNumberOfBytesPerSend,
				    lpOverlapped, lpTransmitBuffers, dwFlags);

	return ret;
}


int APIENTRY WSARecvEx (SOCKET s, char FAR * buf, int len, int *flags)
{
	int	ret;

x_OutputDebugString("WSARecvEx ");

	ret = gft.WSARecvEx (s, buf, len, flags);

	return ret;
}


__declspec( naked ) void WsControl()
{
	_asm {
		jmp		DWORD PTR gft.WsControl;
	}
}

__declspec( naked ) void closesockinfo()
{
	_asm {
		jmp		DWORD PTR gft.closesockinfo;
	}
}


__declspec( naked ) void Arecv()
{
	_asm {
		jmp		DWORD PTR gft.Arecv;
	}
}


__declspec( naked ) void Asend()
{
	_asm {
		jmp		DWORD PTR gft.Asend;
	}
}


__declspec( naked ) void WSHEnumProtocols()
{
	_asm {
		jmp		DWORD PTR gft.WSHEnumProtocols;
	}
}


__declspec( naked ) void inet_network()
{
	_asm {
		jmp		DWORD PTR gft.inet_network;
	}
}


__declspec( naked ) void getnetbyname()
{
	_asm {
		jmp		DWORD PTR gft.getnetbyname;
	}
}


__declspec( naked ) void rcmd()
{
	_asm {
		jmp		DWORD PTR gft.rcmd;
	}
}


__declspec( naked ) void rexec()
{
	_asm {
		jmp		DWORD PTR gft.rexec;
	}
}


__declspec( naked ) void rresvport()
{
	_asm {
		jmp		DWORD PTR gft.rresvport;
	}
}


__declspec( naked ) void sethostname()
{
	_asm {
		jmp		DWORD PTR gft.sethostname;
	}
}


__declspec( naked ) void dn_expand()
{
	_asm {
		jmp		DWORD PTR gft.dn_expand;
	}
}


__declspec( naked ) void s_perror()
{
	_asm {
		jmp		DWORD PTR gft.s_perror;
	}
}


__declspec( naked ) void NPLoadNameSpaces()
{
	_asm {
		jmp		DWORD PTR gft.NPLoadNameSpaces;
	}
}
